//+------------------------------------------------------------------+
//|             _TRO_TTM_History                                     |
//|                                                                  |
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Blue    
#property indicator_color2 DodgerBlue         
#property indicator_color3 DimGray      
#property indicator_color4 Maroon    
#property indicator_color5 Red        
   

//---- parameters
 
extern string myPair    = "";

extern int TTMperiod=6;


double  Low_ma,
	     High_ma,
	     close, L3,H3,
	     Low_third[],
	     High_third[];

//---- buffers

   double     ExtBuffer0[];   
   double     ExtBuffer1[];
   double     ExtBuffer2[];
   double     ExtBuffer3[]; 
   double     ExtBuffer4[];   

 
//+------------------------------------------------------------------+

int myPeriod = 0 ;




//+------------------------------------------------------------------+

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_MN1: tfs="MN"; break;
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
   }
   return(tfs);
} 

//+------------------------------------------------------------------+

int init()
{
   SetIndexBuffer(0,ExtBuffer0);
   SetIndexBuffer(1,ExtBuffer1);
   SetIndexBuffer(2,ExtBuffer2);
   SetIndexBuffer(3,ExtBuffer3);
   SetIndexBuffer(4,ExtBuffer4);
 
   
   SetIndexStyle(0,DRAW_HISTOGRAM, EMPTY, 4, indicator_color1);
   SetIndexStyle(1,DRAW_HISTOGRAM, EMPTY, 4, indicator_color2);
   SetIndexStyle(2,DRAW_HISTOGRAM, EMPTY, 4, indicator_color3);
   SetIndexStyle(3,DRAW_HISTOGRAM, EMPTY, 4, indicator_color4);
   SetIndexStyle(4,DRAW_HISTOGRAM, EMPTY, 4, indicator_color5);
 
   

if (myPair == "") myPair = Symbol();
   
if( myPeriod == 0) myPeriod = Period() ;    

string tPeriod = TimeFrameToString(myPeriod) ;

IndicatorShortName("TRO_TTM "+myPair+"("+tPeriod+")" );
    
return(0);
}

//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
  
//+------------------------------------------------------------------+
int start()
  {
  
   int counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   
   if(counted_bars>0) counted_bars--;
   
   int bars=Bars-counted_bars;


//---- main calculation loop

while(bars>=0)
{          
       
Low_ma  = iMA(NULL,0,TTMperiod,0,MODE_EMA,PRICE_LOW,bars);
High_ma = iMA(NULL,0,TTMperiod,0,MODE_EMA,PRICE_HIGH,bars);
close   = iClose(NULL,0,bars);


L3  = (High_ma- Low_ma) / 3 + Low_ma;
H3  = 2 * (High_ma- Low_ma) / 3 + Low_ma;

while(true)
{
      
  if (close > H3) { PlotHist(4,0,0,0,0,bars) ; break; }
  if (close < L3) { PlotHist(0,0,0,0,4,bars) ; break; }
                    PlotHist(0,0,4,0,0,bars) ; break; 

} // while 
       
bars--; }
 
return(0);

}

//+------------------------------------------------------------------+
      
void PlotHist(int a,int b,int c,int d,int e, int bars)
{

ExtBuffer0[bars]=a;    
ExtBuffer1[bars]=b;
ExtBuffer2[bars]=c;
ExtBuffer3[bars]=d;
ExtBuffer4[bars]=e;
 
}

//+------------------------------------------------------------------+